<template>
  <div>
    <div
      id="modal_galeria_crear"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
      data-bs-backdrop="static"
      data-bs-keyboard="false"
    >
      <div class="modal-dialog mw-650px">
        <div
          id="modal_galeria_crear_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header">
            <h3 class="modal-title">
              Agregar imagenes en la subasta
            </h3>

            <div
              id="modal_galeria_crear_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
              @click="onCerrarModal()"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-0">
            <div class="row">
              <div
                id="modal_galeria_crear_ktinputimagen"
                class="dropzone"
              >
                <div class="dz-message needsclick">
                  <i class="bi bi-file-earmark-arrow-up text-primary fs-3x" />

                  <div class="ms-4">
                    <h3 class="fs-5 fw-bolder text-gray-900 mb-1">
                      Arrastre las imagenes aquí o haga clic para cargar.
                    </h3>
                    <span class="fs-7 fw-bold text-gray-400">Sube hasta 5 archivos</span>
                  </div>
                </div>
              </div>
            </div>
          </div>

          <div class="modal-footer px-10 py-5">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
              @click="onCerrarModal()"
            >
              Cancelar
            </button>
            <button
              id="modal_galeria_crear_btn_guardar"
              type="button"
              class="btn btn-primary"
              @click="onGaleriaRegistrar()"
            >
              <span class="indicator-label">Guardar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import InputMultiArchivo from "@/core/util/InputMultiArchivo";
import BloqueoUI from "@/core/util/BloqueoUI";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Alerta from "@/core/util/Alerta";

export default {
  name: 'ModalGaleriaCrear',
  components: {
  },
  emits: ['onGaleriaListar'],

  data() {
    return {
      componentes: {
        multiArchivo: null,
        bloqueoUI: null,
      },
      mFormulario: {
        imagenes: null,
      },
    };
  },

  mounted() {
    this.componentes.multiArchivo = new InputMultiArchivo('#modal_galeria_crear_ktinputimagen');
    this.componentes.bloqueoUI = new BloqueoUI('#modal_galeria_crear_formulario', '#modal_galeria_crear_btn_guardar');
  },
  methods: {
    onGaleriaRegistrar() {
      this.mFormulario.imagenes = this.componentes.multiArchivo.archivos;
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();

      Servicio.postMultiPart(Ruta.rutaPanelSubastasGaleriaRegistrar(this.$route.params.id), this.mFormulario).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        this.$emit('onGaleriaListar');
        this.cerrarModal();
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Alerta.alertaError(error);
      });
    },

    onCerrarModal() {
      this.mFormulario = {imagenes: null};
      this.componentes.multiArchivo.eliminarArchivos();
    },

    cerrarModal() {
      document.querySelector('#modal_galeria_crear_btn_cerrar').click();
    }
  }
}
</script>